;Assemblieren mit
;a86 ccmacc.asm  liefert ccmacc.com Programm

;Macrodefinitionen

allpush macro
 push bx
 push cx
 push dx
 push bp
 push di
 push si
#em

allpop macro
 pop  si
 pop  di
 pop  bp
 pop  dx
 pop  cx
 pop  bx
#em

negdxbx macro
 not  bx
 not  dx
 add  bx,1
 adc  dx,0
#em

;setzt ein Prozessorregister auf 0, z.B.  clr ax
;!Achtung!, beeinflut auch das C-Flag
clr macro
 xor #1,#1
#em

pushdxbx macro
 push dx
 push bx
#em

popdxbx macro
 pop  bx
 pop  dx
#em

popcxax macro
 pop  ax
 pop  cx
#em

mov_esds macro
 mov  bp,ds
 mov  es,bp
#em

movs4w macro ;ist nur 4 Byte lang, also krzer als mov cx,... rep...
 movsw
 movsw
 movsw
 movsw
#em

;Einige Routinen in diesem Quelltext sind mit #if #endif
;ausgeklammert. Sie werden nicht bentigt, aber als Grundlage
;fr spteres im Text belassen. Sie werden nicht bersetzt, da
;keine Marke erweit1 definiert ist.


 org 0100h ;Standard-Startadresse fr *.COM-Files

;Eintritt mit CS = DS = ES = SS,
;SP zeigt auf das letzte verfgbare word in diesem Segment

START:
 cmp sp,prgende+0400h ;mind. 1KByte Stack sollte frei sein
 jb p_ende            ;zuwenig Speicher, sofort Ende
 mov sp,prgende+0400h ;neuer Stack
 mov bx,sp
 mov cl,04h
 shr bx,cl   ;Byteanzahl -> Paragraphen
 add bx,02h  ;zur Sicherheit
 mov ah,04ah ;ntigen Platz reservieren, Rest freigeben
 int 021h    ;INT$21 Func$4A: setze Speicherblock
 jc p_ende   ;darf nie auftreten
 mov bx,0ffffh
 mov ah,048h ;wieviel Speicher ist frei ?
 int 021h    ;INT$21 Func$48: Speicherbereich zuweisen
 cmp bx,0400h
 jb p_ende   ;unter 16Kbyte = $4000 Byte will ich nicht
 cmp bx,01000h
 jb start1   ;aber mehr als 64KByte = $10000 auch nicht
 mov bx,01000h
start1:
 mov ah,048h ;Speicher holen
 int 021h
 jc p_ende   ;darf nicht auftreten
 mov w[PUFADR],0 ;Pufferadresse als FARPTR
 mov [PUFADR+2],ax
 shl bx,1    ;Paragraphen -> Byteanzahl
 shl bx,1
 shl bx,1
 shl bx,1
 or bx,bx
 jnz start2
 dec bx      ;statt $10000 gleich $ffff nehmen
start2:
 mov [PUFLEN],bx ;Pufferlnge in Byte
 call arbeit     ;eigentliches Programm
 mov es,[PUFADR+2]
 mov ah,049h     ;Speicher freigeben
 int 021h        ;INT$21 Func$49: Speicherbereich freigeben
p_ende:
 mov ax,04c00h ;Programm beenden
 int 021h      ;INT$21 Func$4C: beende Programm


Meldungen:
msg1: db 'I read or write parts of memory cards.',0dh,0ah
      db 'The CCMACC (C) by SWB, 22.08.1992',0dh,0ah,0
msgreaok: db 'Read ok.',0dh,0ah,0
msgwrido: db 'Write done.',0dh,0ah,0
msgfoer: db 'File-open error',7,0dh,0ah,0
msgfrer: db 'File-read error',7,0dh,0ah,0
msgfwer: db 'File-write error',7,0dh,0ah,0
msgverer: db 'NOT ',7
msgverok: db 'all equal during verify',0dh,0ah,0
msgbper: db 'Bad/impossible parameters. I need:',7,0dh,0ah
	 db 'Mode Medium Bank Adr Number File',0dh,0ah,0


Variablen:
PUFADR: dw 0,0 ;FARPTR
PUFLEN: dw 0
CCMOLD: dw 0
CCMRW: db 0
CCMMED: db 0
CCMPAGE: db 0
CCMADR: dw 0,0 ;32 Bit lineare Adresse relativ zu $C0000
CCMLEN: dw 0
FNAME: dw 0
FHAND: dw 0


arbeit:
 mov si,msg1  ;Startmeldung ausgeben
 call PRTSTG
 mov si,0080h ;die Kommandozeile des DOS
 cld          ;interpretieren, wenn sie > 2 Zeichen ist
 lodsb
 cmp al,3
 jb ar1err
 mov ah,00h
 call IGNBLNK
 lodsb
 call CCBIG
 cmp al,'R'  ;Read, Lesen von Karte ?
 jz ar1
 cmp al,'W'  ;Write, Schreiben auf Karte ?
 jz ar1
 cmp al,'V'  ;Verify, Karte und File vergleichen ?
 jz ar1
ar1err:
 mov si,msgbper  ;Fehler, ungltiges Kommando
 jmp ar_end
ar1:
 mov [CCMRW],al
 call IGNBLNK
 lodsb
 call CCBIG
 cmp al,'A'  ;Karte A, Karte B, oder externes ROM R ?
 jz ar2
 cmp al,'B'
 jz ar2
 cmp al,'R'
 jnz ar1err  ;Fehler, ungltiges Medium
ar2:
 mov [CCMMED],al
 call TSTNUM ;Bank-Nummer ?
 or ch,ch
 jz ar1err
 or dh,bh
 or dx,dx    ;nur 0 bis $ff zugelassen
 jnz ar1err  ;Fehler, unmgliche Banknummer
ar3:
 mov [CCMPAGE],bl
 call TSTNUM ;Adresse auf Karte ? (auf der Bank)
 or ch,ch
 jz ar1err
 cmp dx,001h ;nur 0 bis $1ffff zugelassen
 ja ar1err   ;Fehler, Adresse zu gro
ar4:
 mov [CCMADR],bx
 mov [CCMADR+2],dx
 call TSTNUM ;Anzahl der Byte ?
 or ch,ch
 jz ar1err
 or dx,dx    ;nur 1 bis $ffff zulassen
 jnz ar1err  ;Fehler, zu gro
 mov ax,dx
 or ax,bx
 jz ar1err   ;Fehler, Anzahl war 0
 cmp bx,[PUFLEN]
 ja ar1err   ;Fehler, pat nicht in Speicher rein
 mov ax,[CCMADR]
 add ax,bx
 adc dx,[CCMADR+2] ;dx war 0
 cmp dx,002h
 ja ar1err   ;Fehler, pat nicht auf Karte
 jb ar5      ;pat in Kartenbereich (Adresse+Bytes<=$20000)
 or ax,ax
 jnz ar1err  ;Fehler, pat nicht auf Karte
ar5:
 mov [CCMLEN],bx
 mov ah,0dh
 call IGNBLNK ;Filename folgt ?
 jz ar1err    ;Fehler, Filename fehlt
ar6:
 call F_CNAME
 jc ar1err    ;Fehler, Filename fehlt
 mov ax,03c00h   ;Func$3C: Create (fr Lesen von Karte)
 clr cx          ;Attributcode
 cmp b[CCMRW],'R'
 jz ar_auf
 mov ax,03d00h   ;Func$3D: Open (fr Schreiben und Verify)

ar_auf:
 mov [FNAME],dx  ;Namensadresse sichern
 int 021h        ;INT$21
 jnc ar_auf1
 mov si,msgfoer  ;Fehler beim Datei ffnen/anlegen
 jmp ar_end
ar_auf1:
 mov [FHAND],ax  ;Handle sichern
 cmp b[CCMRW],'R'
 jz ar_rea
 jmp ar_wri

ar_rea:
;von Karte lesen, File schreiben
 call SCCM_ON    ;Karte&Bank einblenden
 cld             ;Daten in Puffer kopieren
 mov di,[PUFADR] ;Ziel ES:DI nie Segmentberlauf
 push es
 mov es,[PUFADR+2]
 mov si,0000fh   ;Quelle DS:SI so, das Segmentberlauf unwahrscheinlich
 mov bx,[CCMADR]
 and si,bx
 mov dx,[CCMADR+2]
 mov cx,0004h
ar_rea1:
 shr dx,1
 rcr bx,1
 loop ar_rea1
 add bx,0c000h   ;Basisadresse C000:0000
 mov cx,[CCMLEN] ;Byteanzahl
 push ds
 mov ds,bx
ar_rea3:
 movsb
 or si,si
 jnz ar_rea2
 add bx,01000h   ;Segmentberlauf, DS korrigieren
 mov ds,bx
ar_rea2:
 loop ar_rea3
 pop ds
 pop es
 call SCCM_OLD   ;Karte ausblenden
 mov bx,[FHAND]  ;File schreiben
 mov cx,[CCMLEN] ;Byteanzahl
 mov dx,[PUFADR]
 push ds
 cs: mov ds,[PUFADR+2]
 mov ah,040h
 int 021h        ;INT$21 Func$40: Bytes schreiben
 pop ds
 pushf           ;Status sichern
 push ax
 mov bx,[FHAND]
 mov ah,03eh
 int 021h        ;INT$21 Func$3E: File schlieen
 pop ax
 popf            ;Status vom Schreiben
 jc ar_rea5      ;File-Schreibfehler
;Leider liefert der Portfolio auch ein Carry, wenn er weniger
;Byte als angegeben geschrieben hat (normaler PC nicht).
;Aber die geschriebene Bytezahl in AX ist ein Vielfaches von 080H,
;und echte Fehlernummern sind kleiner.
 cmp ax,[CCMLEN] ;Test erfolgt, falls DOS ein ok meldet
 jz ar_rea7      ;alles ok.
 jmp ar_rea60    ;Disk voll
ar_rea5:
 test al,07fh ;wegen des Portfolio-DOS-Fehlers
 jnz ar_rea61 ;hier nochmal auf Disk voll testen
ar_rea60:
 mov al,255   ;Disk voll Fehler
ar_rea61:
 push ax      ;Fehlernummer sichern
 mov dx,[FNAME]
 mov ah,041h
 int 021h     ;INT$21 Func$41: Datei lschen
 pop ax
ar_rea8:
 mov si,msgfwer  ;Fehler beim Fileschreiben
 jmp ar_end
ar_rea7:
 mov si,msgreaok ;Lesen erfolgreich beendet
 jmp ar_end


ar_wri:
;File lesen, auf Karte schreiben oder nur vergleichen
 mov bx,[FHAND]  ;File lesen
 mov cx,[CCMLEN] ;Byteanzahl
 mov dx,[PUFADR]
 push ds
 cs: mov ds,[PUFADR+2]
 mov ah,03fh
 int 021h        ;INT$21 Func$3F: Bytes lesen
 pop ds
 pushf           ;Status
 push ax         ;Byteanzahl
 mov bx,[FHAND]
 mov ah,03eh
 int 021h        ;INT$21 Func$3E: File schlieen
 pop ax
 popf
 jnc ar_wri5
ar_wri0:
 mov si,msgfrer
 jmp ar_end      ;Fehler beim Filelesen
ar_wri5:
 or ax,ax
 jz ar_wri0      ;Filelnge 0 auch als Fehler werten
 mov [CCMLEN],ax ;neue Byteanzahl
 call SCCM_ON    ;Karte&Bank einblenden
;Daten aus Puffer auf Karte
;dabei Kartenadresse $0000A nie beschreiben, dafr gibt
;es nur eine Segment-Offset Kombination: $C000:$000A
 cld             ;Daten auf Karte kopieren
 mov di,0000fh   ;Ziel ES:DI so, da Segmentberlauf unwahrscheinlich
 mov bx,[CCMADR]
 and di,bx
 mov dx,[CCMADR+2]
 mov cx,0004h
ar_wri1:
 shr dx,1
 rcr bx,1
 loop ar_wri1
 add bx,0c000h   ;Basisadresse C000:0000
 push es
 mov es,bx
 clr bp          ;wird auf $ffff gesetzt wenn Vergleich Ungleichheit findet
 mov ah,[CCMRW]  ;Modus, Karte beschreiben nur bei W
 mov cx,[CCMLEN] ;Byteanzahl
 mov si,[PUFADR] ;Quelle DS:SI nie Segmentberlauf
 push ds
 cs: mov ds,[PUFADR+2]
ar_wri3:
 cmp di,0000ah   ;Suche nach C000:000A
 jnz ar_wri21
 cmp bx,0c000h
 jnz ar_wri21
 inc si          ;berspringe diese Adresse ohne Transport/Vergleich
 inc di
 jmp ar_wri22
ar_wri21:
 lodsb           ;hole Quelle
 cmp ah,'W'
 jnz ar_wri23    ;kein Schreiben
 es: mov [di],al ;schreibe Ziel
ar_wri23:
 scasb           ;vergleiche mit Ziel
 jz ar_wri22     ;Gleichheit
 mov bp,0ffffh   ;Flag fr ungleich
ar_wri22:
 or di,di
 jnz ar_wri2
 add bx,01000h   ;Segmentberlauf, ES korrigieren
 mov es,bx
ar_wri2:
 loop ar_wri3
 pop ds
 pop es
 call SCCM_OLD
 cmp b[CCMRW],'W'
 jnz ar_wri8
 mov si,msgwrido ;Schreiben ausgefhrt
 call PRTSTG
ar_wri8:
 or bp,bp
 mov si,msgverer
 or bp,bp
 jnz ar_end      ;Vergleich ergab Unterschiede
 mov si,msgverok ;Vergleich ergab keine Unterschiede
ar_end:
 call PRTSTG
 ret


SCCM_ON:
;schaltet CCM A:, CCM B: oder ext.ROM an je nach CCMMED Inhalt
;sichert alten Status in CCMOLD
 mov ax,02400h ;als Get
 int 061h      ;INT$61 Func$24 Get/Set ROM/CCM space state
 mov [CCMOLD],dx
 mov al,[CCMMED]
 mov dx,00101h
 cmp al,'A'
 jz sccm_on1
 mov dx,00202h
 cmp al,'B'
 jz sccm_on1
 mov dx,00003h
sccm_on1:
 mov ax,02401h
 int 061h
 mov al,[CCMPAGE] ;Bank innerhalb der Karte whlen
 push ds
 mov dx,0c000h    ;Basisadresse der Karte
 mov ds,dx
 mov [0000ah],al  ;Bankregister
 pop ds
 ret


SCCM_OLD:
;Stellt alten CCM/ROM-Zustand wieder her
 mov ax,02401h
 mov dx,[CCMOLD]
 int 061h    ;INT$61 Func$24 Get/Set ROM/CCM space state
 ret


IGNBLNK:
;incr. SI soweit (falls berhaupt), bis es nicht mehr auf Spaces zeigt
;incr. SI nochmal, falls es auf Suchzeichen zeigte
;in:  SI: Textzeiger
;     AH: Suchzeichen
;out: SI: Textzeiger
;     AL: Textzeichen auf das SI zeigt
;     Flags: von CMP Zeichen,Suchzeichen
;fre: alle anderen Register
 cld
ignblnk1:
 lodsb         ;hole Zeichen
 cmp  al,020H
 jz   ignblnk1 ;berspringe Spaces
 cmp  al,ah    ;Suchzeichen gefunden ?
 jnz  ignblnk2 ; nein, SI zeigt hinter Space
 lodsb         ; ja, nchstes Zeichen holen
ignblnk2:      ;SI zeigt eins zu weit!
 lahf
 dec  si
 sahf
 ret




TSTNUM:
;teste ob der Text eine 32Bit-Integer-Zahl ist, wenn ja wandle ihn
;in:  SI: Textzeiger
;out: SI:  -"- hinter Zahl
;     DXBX: gewandelte Zahl
;     CH: $00=keine_Zahl,  $01=dezimal,  $80=hexadezimal
;fre: DI
 clr  bx      ;DXBX=0
 clr  dx
 clr  cx
 mov  ah,'$'  ;Hexzahl ?
 call IGNBLNK ;Spaces berlesen, erledigt auch cld
 jnz  tnumd0
;Hexzahl wandeln
tnumh2:
 lodsb
 call TSTZIF ;Ziffer 0 bis 9 ?
 jnc  tnumh1 ; ja
 call CCBIG  ;in Grobuchstaben
 cmp  al,'A'
 jb   tnumh4 ;zu klein
 cmp  al,'F'
 ja   tnumh4 ;zu gro
 sub  al,'A'-10 ;'A' bis 'F' nach $A bis $F
tnumh1:
 mov  cx,4
tnumh5:
 sal  bx,1
 rcl  dx,1
 loop tnumh5
 or   bl,al
 jmp  tnumh2
tnumh4:
 dec  si
 mov  ch,080h   ;es war eine Hexzahl
tnumh6:
 ret

tnumd0:
;Dezimalzahl wandeln
 mov  ah,'-'  ;negatives Vorzeichen ?
 call IGNBLNK
 push di
 pushf        ;Flag dafr sichern
 sub sp,8     ;Platz
 mov bp,sp    ;als Zwischenspeicher
 clr  ax
 mov  di,bp   ;auf 0 setzen
 mov  cx,4
 rep stosw    ;b[bp]: Zahl gltig-Flag
tnumd1:
 lodsb
 call TSTZIF  ;teste ob Ziffer
 jc   tnumd2  ; nein
 mov  b[bp],0afh ;Dezimal-Integer
 mov  cx,4    ;altes *10
tnumd10:
 shl  w[bp+2],1 ;Sammlung als BCD-Kode in w[BP+6]w[BP+4]w[BP+2]
 rcl  w[bp+4],1
 rcl  w[bp+6],1 ;alles ber 12(!) Stellen fllt automatisch raus
 loop tnumd10
 or   b[bp+2],al ;Ziffer einfgen
 jmp  tnumd1    ;alle Ziffern sammeln
tnumd2:
 cmp  b[bp+6],021h ;wenn >2147483647, lsche hchste Ziffer
 jb   tnumd3    ;fr Integer nur 10 Stellen:
 ja   tnumd4    ; b[BP+6]w[BP+4]w[BP+2]
 cmp  w[bp+4],04748h
 jb   tnumd3
 ja   tnumd4
 cmp  w[bp+2],03647h
 jbe  tnumd3
tnumd4:
 and  b[bp+6],0fh
tnumd3:
 clr  bx ;wandle die BCD-Zahl in binr
 clr  dx
 mov  ch,10 ;10 Stellen
tnumd5:
 mov  cl,9
 mov  ax,bx
 mov  di,dx
tnumd6:
 add  bx,ax ;DXBX=DXBX*10
 adc  dx,di
 dec  cl
 jnz  tnumd6
 mov  cl,4
 clr  ax
tnumd7:
 shl  w[bp+2],1 ;1 Digit holen
 rcl  w[bp+4],1
 rcl  b[bp+6],1
 rcl  ax,1
 dec  cl
 jnz  tnumd7
 add  bx,ax   ;dazuaddieren
 adc  dx,0
 dec  ch
 jnz  tnumd5  ;alle 10 Digits
 mov  ch,[bp+0] ;Flag fr Gltigkeit
 mov  b[bp+1],0 ;Zahlentyp: 32 Bit Integer
 add sp,8    ;Stackplatz freigeben
 popf        ;Flag ob - Vorzeichen
 jnz  tnumd8 ;nein
 negdxbx     ;DXBX=-DXBX
tnumd8:
 pop  di
 dec  si
 ret


TSTZIF:
;wenn AL = '0' bis '9' dann AL = 0 bis 9, Flag NC
;sonst AL unverndert, Flag C
 cmp  al,'0'
 jc   ret
 cmp  al,'9'+1
 cmc
 jc   ret
 sub  al,'0' ;lscht C-Flag
 ret


CCBIG:
;konvertiert 'a'-'z' in 'A'-'Z' in Register AL
 cmp  al,'a'
 jb   ret
 cmp  al,'z'
 ja   ret
 sub  al,020h
 ret


PRTSTG:
;Druckt einen Text bis zu einem $00 (wird nicht gedruckt) aus.
;in:  SI: Zeiger auf Text
;out: SI: Zeiger hinter Text ($00)
;frei: BX, CX, DX, BP, DI
 cld
 lodsb       ;Zeichen holen in AL
 or   al,al  ;wenn $00 gefunden: Ende
 jz   prtstg2
 call CHROUT ;Zeichen drucken
 jmp  PRTSTG
prtstg2:
 ret


#if erweit1

PRTNUM:
;druckt die vorzeichenbehaftete Zahl aus DXBX rechtsjustiert
;in der in CL angegebenen Anzahl Spaces
;sollten es zu wenig Spaces sein, wird Zahl einfach so gedruckt
;falls CL>128, so wird eine Hexzahl mit CL-128 Ziffern gedruckt
;falls CL=128, Hexzahl ohne fhrende Nullen
;in:  DXBX: Zahl
;     CL: Anzahl der Spaces
 or   cl,cl
 js   PRTH   ;Hexzahl drucken
;Dezimal Integer drucken
 mov  ax,10
 push ax     ;10 als Ende-Flag
 clr  ch     ;CH: 0
 dec  cl     ;CL: Spaces
 or dx,dx    ;teste Vorzeichen
 jns  pnumd1 ;kein Vorzeichen, CH=0
 mov  ch,'-'
 dec  cl     ;'-' braucht Platz
 negdxbx     ;Betrag bilden
pnumd1:
 mov  bp,10  ;Divisor =10 (bleibt bei DIVIL erhalten)
 clr  di
pnumd2:
 push cx     ;sign and spaces
 call DIVIL  ;DXBX=DXBX/DIBP,  CXAX=Rest
 pop  cx     ;sign and spaces
 push ax     ;sichere eine Ziffer (0 bis 9)
 mov  ax,bx  ;nur noch fhrende 0en ?
 or   ax,dx
 jz   pnumd3 ; ja, hchste Ziffer <>0 schon bearbeitet
 dec  cl     ;dekrementiere Spaces
 jmp  pnumd2
pnumd3:
 dec  cl
 js   pnumd4 ;keine (weiteren) Spaces
 mov  al,' ' ;Space ausgeben
 call CHROUT
 jmp  pnumd3
pnumd4:
 mov  al,ch  ;nur '-' drucken, sonst nichts
 or   al,al
 jz   pnumd5
 call CHROUT
pnumd5:
 pop  ax
 cmp  al,10  ;Ziffer ?
 jae  pnumd6 ; nein, Endeflag (10)
 add  al,'0' ;Ziffer in ASCII
 call CHROUT ;drucken
 jmp  pnumd5 ;alle Ziffern ausgeben
pnumd6:
 ret


PRTH:
;wie PRTNUM, aber Hex mit $ davor
;CL-128: Anzahl der Hexziffern (max. werden 8 gedruckt)
;CL=128: Hexzahl ohne fhrende Nullen
 MOV  AL,'$'
 CALL CHROUT
 SUB  CL,080H
 MOV  CH,8
PRTH3:
 mov  al,03h   ;ASCII-Zeichen '0' 4*rechtsverschoben
 push cx
 mov  cx,4
prth4:
 shl  bx,1
 rcl  dx,1
 rcl  al,1
 loop prth4
 pop  cx
 CMP  AL,'9'
 jbe  PRTH1
 ADD  AL,7
PRTH1:
 or   cl,cl
 jnz  prth5
 cmp  ch,1   ;fhrende Nullen bergehen
 jz   prth6  ;aber letzte 0 drucken
 cmp  al,'0'
 jz   prth2
 mov  cl,255 ;Ende der fhrenden 0en
prth5:
 CMP  CL,CH
 jc   prth2  ;Ziffer noch nicht ausgeben
prth6:
 CALL CHROUT
prth2:
 DEC  CH
 JNZ  PRTH3
 RET


DIVIL:
;32 Bit unsigned Division
;DXBX = DXBX / DIBP
;CXAX = Rest
;unverndert: SI, DIBP
 push si
 clr  si
 clr  ax
 mov  cx,32  ;fr 32 Bit
divil0:
 shl  bx,1
 rcl  dx,1
 rcl  ax,1
 rcl  si,1
 sub  ax,bp
 sbb  si,di
 jc   divil1
 or   bl,1
 loop divil0 ;zwei Schleifenenden sind
 mov  cx,si
 pop  si
 ret
divil1:
 add  ax,bp
 adc  si,di
 loop divil0 ; etwas schneller als ein Ende
 mov  cx,si
 pop  si
 ret

#endif


CRLF:
;erzeugt Carriage Return und Line Feed
 mov  al,0dh
 call CHROUT
 mov  al,0ah
 call CHROUT
 ret


CHROUT:
;gibt das Byte aus AL aus
;Alle Register bleiben erhalten
 push ax
 allpush
 mov dl,al
 mov ah,02h
 int 021h   ;INT$21 Func$02: Zeichen ausgeben
 allpop
 pop  ax
 ret


#if erweit1

GETKEY:
;wartet auf Tastendruck und liefert den ASCII-Code in AL (AH=0)
;ist es ein erweiterter Code, ist AL=0 und Code in AH
 allpush
 mov  ah,7
 int  021h    ;INT$21 Func$07: Zeichen lesen von Standard-Eingabe
 sub  ah,ah
 or   al,al
 jnz  getkey1 ;kein erweiterter Tastencode
 mov  ah,7
 int  021h    ;INT$21 Func$07:
 mov  ah,al
 sub  al,al
getkey1:
 allpop    ;erweiterter Code in AH, AL=0
 ret

#endif


F_CNAME:
;Setzt hinter den ab SI liegenden Filenamen ein $00 als
;Endekennzeichen zur Verwendung bei DOS Open/Create.
;Liefert in DX Adresse des Filenamens, SI zeigt hinter das $00.
;Namensende wird anhand von $00, $0D oder $20 erkannt.
;in:  SI: Textzeiger
;out: SI: -"-   hinter Namen
;     AL: Zeichen, das durch $00 berschrieben wurde
;     DX: zeigt auf erstes Byte des Filenamens
;     Flags: Filename mit mind. 1Zeichen: NC
;            kein String oder zu lang   : C
 cld
 mov cx,007fh ;max. 127 Zeichen
 mov dx,si    ;Anfang Filename
f_cname0:
 lodsb
 cmp al,00h
 jz f_cname1
 cmp al,0dh
 jz f_cname1
 cmp al,020h
 jz f_cname1
 inc bx
 loop f_cname0
f_cname2:
 dec si       ;Fehler
 stc
 ret
f_cname1:
 cmp cx,007f
 jz f_cname2
 mov b[si]-1,0  ;$00 dahinter
 clc
 ret


prgende: ;mu ganz am Ende stehen

